%define	debug_package		%{nil}
%define VirtualEnvironment	%{name}-%{version}
%define VirtualEnvironmentPath  %{_prefix}/local/lib/PythonVirtualEnvironments

%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^lib.*[.-][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f].so.*|^libcuda|^libtbb|^libz
%global __requires_exclude_from %{VirtualEnvironmentPath}/%{VirtualEnvironment}/lib*
%global __provides_exclude_from %{VirtualEnvironmentPath}/%{VirtualEnvironment}/lib*

Name:		maryam
Version:	2.5.1
Release:	2%{?dist}
Summary:	OWASP Maryam is a modular/optional open source framework based on OSINT and data gathering
Group:		Applications
License:	GPL3
Source1:	%{name}-%{version}.tar.gz
URL:		https://github.com/saeeddhqan/Maryam
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if 0%{?fedora}
%define __python3 /usr/bin/python3.10
BuildRequires:  python3-virtualenv python3.10-devel
Requires:	%{__python3}
%endif

%if 0%{?centos} == 9 || 0%{?rhel} == 9
%define __python3 /usr/bin/python3
BuildRequires:  python3-virtualenv python3-devel
Requires:	%{__python3}
%endif

%if 0%{?amzn}
BuildRequires:  rh-python36-python-virtualenv
BuildRequires:  rh-python38-python rh-python38-python-devel
BuildRequires:  rust
Requires:       rh-python38-python
%endif

%if 0%{?centos} == 8 || 0%{?rhel} == 8
%define __python3 /usr/bin/python3.8
BuildRequires:  python3-virtualenv python38-devel python38
Requires:       %{__python3}
%endif

%if 0%{?centos} == 7 && 0%{?amzn} == 0
BuildRequires:  python36-virtualenv
BuildRequires:  rh-python38-python rh-python38-python-devel
Requires:       rh-python38-python
%endif

%description
OWASP Maryam is a modular/optional open source framework based on OSINT and
data gathering. Maryam is written in Python programming language and it’s
designed to provide a powerful environment to harvest data from open sources
and search engines and collect data quickly and thoroughly.

%prep
%setup -cT
sudo mkdir -p %{VirtualEnvironmentPath}
sudo chown %(id -u):%(id -g) %{VirtualEnvironmentPath}
cd %{VirtualEnvironmentPath}
rm -rf %{VirtualEnvironment}

%if 0%{?fedora}
virtualenv -p $(which python3.10) %{VirtualEnvironment}
%endif

%if 0%{?centos} == 9 || 0%{?rhel} == 9
virtualenv %{VirtualEnvironment}
%endif

%if 0%{?centos} == 8
virtualenv-3 -p $(which python3.8) %{VirtualEnvironment}
%endif

%if 0%{?centos}0%{?amzn} == 70
echo virtualenv-3 -p $(echo which python3 | scl enable rh-python38 -) %{VirtualEnvironment} | scl enable rh-python38 -
%endif

%if 0%{?amzn}
echo virtualenv -p $(echo which python3.8 | scl enable rh-python38 -) %{VirtualEnvironment} | scl enable rh-python36 -
%endif

%build
cd %{VirtualEnvironmentPath}
sh -c "cd %{VirtualEnvironment}; source bin/activate; pip3 install --upgrade pip"

%if 0%{?fedora}
sh -c "cd %{VirtualEnvironment}; source bin/activate; pip3 install maryam"
%endif

%install
export QA_RPATHS=$[ 0x0001|0x0002 ]
%if 0%{?fedora} || 0%{?centos}
%{__mkdir_p} %{buildroot}%{VirtualEnvironmentPath}
cd %{VirtualEnvironmentPath}
rsync -a --sparse %{VirtualEnvironment} %{buildroot}%{VirtualEnvironmentPath}
#find %{VirtualEnvironment} | cpio -pdm %{buildroot}%{VirtualEnvironmentPath}

mkdir -p %{buildroot}/%{_bindir}
cat > %{buildroot}/%{_bindir}/maryam << 'EOF'
#!/bin/sh

N=$(basename $0)
MA=%{VirtualEnvironment}
VE=%{VirtualEnvironmentPath}

if [ -d $VE ]; then
        source $VE/$MA/bin/activate
        exec python3 $VE/$MA/bin/$N "$@"
else
        echo $0 cannot be found
        exit 2
fi
EOF
%endif

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(644,root,root,755)
%attr(0755,root,root)	%{_bindir}/%{name}
%attr(0755,root,root)	%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin/*
%{VirtualEnvironmentPath}/%{VirtualEnvironment}

%changelog
* Wed Mar 29 2023 Lawrence R. Rogers <lrr@cert.org> - 2.5.1-2
* Release 2.5.1-2
	Version 2.5.1-2

* Mon Nov 14 2022 Lawrence R. Rogers <lrr@cert.org> - 2.5.1-1
* Release 2.5.1-1
	Version 2.5.1

* Wed May 26 2021 Lawrence R. Rogers <lrr@cert.org> 2.2.6.post1-1
* Release 2.2.6.post1-1
	Version 2.2.6.post1
